/* 
   The Jitterbug report tracking system

   Copyright (C) Andrew Tridgell 1997

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Pull out a message ID number from a piece of email. This isn't done
  with a script to prevent hackers 

  This is meant for use with the mail processing scripts in the mail
  directory of the jitterbug distribution. It is not part of the main
  Jitterbug cgi-bin program.

*/

#include "includes.h"


static int getid(char *fname)
{
	char *buf, *p1, *p2, *p3;
	struct stat st;
	int fd;

	if (stat(fname, &st)) return 0;

	buf = malloc(st.st_size+1);
	if (!buf) return 0;
	
	fd = open(fname,O_RDONLY);
	if (fd == -1) return 0;

	if (read(fd, buf, st.st_size) != st.st_size) return 0;

	buf[st.st_size] = 0;

	p1 = buf;
	while ((p1 = strstr(p1, "\nSubject:"))) {
		p1 += 9;
		p2 = strchr(p1, '\n');
		if (!p2) return 0;
		*p2++ = 0;
		p3 = p1;
		while ((p3 = strstr(p3, "PR#"))) {
			if (atoi(p3+3)) return atoi(p3+3);
			p3 += 3;
		}
		p3 = p1;
		while ((p3 = strstr(p3, "BUG#"))) {
			if (atoi(p3+4)) return atoi(p3+4);
			p3 += 4;
		}
		p1 = p2;
	}
	return 0;
}


int main(int argc, char *argv[])
{
	printf("%d\n", getid(argv[1]));
	return 0;
}
